// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from clober_msgs:msg/ControllerState.idl
// generated code does not contain a copyright notice

#ifndef CLOBER_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_HPP_
#define CLOBER_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


#ifndef _WIN32
# define DEPRECATED__clober_msgs__msg__ControllerState __attribute__((deprecated))
#else
# define DEPRECATED__clober_msgs__msg__ControllerState __declspec(deprecated)
#endif

namespace clober_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ControllerState_
{
  using Type = ControllerState_<ContainerAllocator>;

  explicit ControllerState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->battery_voltage = 0.0;
      this->charging_voltage = 0.0;
      this->current_12v = 0.0;
      this->current_24v = 0.0;
      this->temperature = 0.0;
      this->emergency_stop = false;
    }
  }

  explicit ControllerState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->battery_voltage = 0.0;
      this->charging_voltage = 0.0;
      this->current_12v = 0.0;
      this->current_24v = 0.0;
      this->temperature = 0.0;
      this->emergency_stop = false;
    }
  }

  // field types and members
  using _battery_voltage_type =
    double;
  _battery_voltage_type battery_voltage;
  using _charging_voltage_type =
    double;
  _charging_voltage_type charging_voltage;
  using _current_12v_type =
    double;
  _current_12v_type current_12v;
  using _current_24v_type =
    double;
  _current_24v_type current_24v;
  using _temperature_type =
    double;
  _temperature_type temperature;
  using _fault_flags_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other>;
  _fault_flags_type fault_flags;
  using _emergency_stop_type =
    bool;
  _emergency_stop_type emergency_stop;

  // setters for named parameter idiom
  Type & set__battery_voltage(
    const double & _arg)
  {
    this->battery_voltage = _arg;
    return *this;
  }
  Type & set__charging_voltage(
    const double & _arg)
  {
    this->charging_voltage = _arg;
    return *this;
  }
  Type & set__current_12v(
    const double & _arg)
  {
    this->current_12v = _arg;
    return *this;
  }
  Type & set__current_24v(
    const double & _arg)
  {
    this->current_24v = _arg;
    return *this;
  }
  Type & set__temperature(
    const double & _arg)
  {
    this->temperature = _arg;
    return *this;
  }
  Type & set__fault_flags(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>, typename ContainerAllocator::template rebind<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other>>::other> & _arg)
  {
    this->fault_flags = _arg;
    return *this;
  }
  Type & set__emergency_stop(
    const bool & _arg)
  {
    this->emergency_stop = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    clober_msgs::msg::ControllerState_<ContainerAllocator> *;
  using ConstRawPtr =
    const clober_msgs::msg::ControllerState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      clober_msgs::msg::ControllerState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      clober_msgs::msg::ControllerState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__clober_msgs__msg__ControllerState
    std::shared_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__clober_msgs__msg__ControllerState
    std::shared_ptr<clober_msgs::msg::ControllerState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ControllerState_ & other) const
  {
    if (this->battery_voltage != other.battery_voltage) {
      return false;
    }
    if (this->charging_voltage != other.charging_voltage) {
      return false;
    }
    if (this->current_12v != other.current_12v) {
      return false;
    }
    if (this->current_24v != other.current_24v) {
      return false;
    }
    if (this->temperature != other.temperature) {
      return false;
    }
    if (this->fault_flags != other.fault_flags) {
      return false;
    }
    if (this->emergency_stop != other.emergency_stop) {
      return false;
    }
    return true;
  }
  bool operator!=(const ControllerState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ControllerState_

// alias to use template instance with default allocator
using ControllerState =
  clober_msgs::msg::ControllerState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace clober_msgs

#endif  // CLOBER_MSGS__MSG__DETAIL__CONTROLLER_STATE__STRUCT_HPP_
