// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from clober_msgs:msg/Command.idl
// generated code does not contain a copyright notice
#include "clober_msgs/msg/detail/command__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `command`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
clober_msgs__msg__Command__init(clober_msgs__msg__Command * msg)
{
  if (!msg) {
    return false;
  }
  // command
  if (!rosidl_runtime_c__double__Sequence__init(&msg->command, 0)) {
    clober_msgs__msg__Command__fini(msg);
    return false;
  }
  return true;
}

void
clober_msgs__msg__Command__fini(clober_msgs__msg__Command * msg)
{
  if (!msg) {
    return;
  }
  // command
  rosidl_runtime_c__double__Sequence__fini(&msg->command);
}

bool
clober_msgs__msg__Command__are_equal(const clober_msgs__msg__Command * lhs, const clober_msgs__msg__Command * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // command
  if (!rosidl_runtime_c__double__Sequence__are_equal(
      &(lhs->command), &(rhs->command)))
  {
    return false;
  }
  return true;
}

bool
clober_msgs__msg__Command__copy(
  const clober_msgs__msg__Command * input,
  clober_msgs__msg__Command * output)
{
  if (!input || !output) {
    return false;
  }
  // command
  if (!rosidl_runtime_c__double__Sequence__copy(
      &(input->command), &(output->command)))
  {
    return false;
  }
  return true;
}

clober_msgs__msg__Command *
clober_msgs__msg__Command__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Command * msg = (clober_msgs__msg__Command *)allocator.allocate(sizeof(clober_msgs__msg__Command), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(clober_msgs__msg__Command));
  bool success = clober_msgs__msg__Command__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
clober_msgs__msg__Command__destroy(clober_msgs__msg__Command * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    clober_msgs__msg__Command__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
clober_msgs__msg__Command__Sequence__init(clober_msgs__msg__Command__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Command * data = NULL;

  if (size) {
    data = (clober_msgs__msg__Command *)allocator.zero_allocate(size, sizeof(clober_msgs__msg__Command), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = clober_msgs__msg__Command__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        clober_msgs__msg__Command__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
clober_msgs__msg__Command__Sequence__fini(clober_msgs__msg__Command__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      clober_msgs__msg__Command__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

clober_msgs__msg__Command__Sequence *
clober_msgs__msg__Command__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  clober_msgs__msg__Command__Sequence * array = (clober_msgs__msg__Command__Sequence *)allocator.allocate(sizeof(clober_msgs__msg__Command__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = clober_msgs__msg__Command__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
clober_msgs__msg__Command__Sequence__destroy(clober_msgs__msg__Command__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    clober_msgs__msg__Command__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
clober_msgs__msg__Command__Sequence__are_equal(const clober_msgs__msg__Command__Sequence * lhs, const clober_msgs__msg__Command__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!clober_msgs__msg__Command__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
clober_msgs__msg__Command__Sequence__copy(
  const clober_msgs__msg__Command__Sequence * input,
  clober_msgs__msg__Command__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(clober_msgs__msg__Command);
    clober_msgs__msg__Command * data =
      (clober_msgs__msg__Command *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!clober_msgs__msg__Command__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          clober_msgs__msg__Command__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!clober_msgs__msg__Command__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
